#include "stdio.h"    
#include "stdlib.h"   
#include "io.h"  
#include "math.h"  
#include "time.h"

#define OK 1
#define ERROR 0
#define TRUE 1
#define FALSE 0

typedef int Status;	/* StatusǺ,ֵǺ״̬룬OK */  
typedef int Boolean; /* Booleanǲ,ֵTRUEFALSE */

typedef char VertexType; /* Ӧû */
typedef int EdgeType; /* ϵȨֵӦû */

#define MAXSIZE 9 /* 洢ռʼ */
#define MAXEDGE 15
#define MAXVEX 9
#define INFINITY 65535

typedef struct
{
	VertexType vexs[MAXVEX]; /*  */
	EdgeType arc[MAXVEX][MAXVEX];/* ڽӾ󣬿ɿ߱ */
	int numVertexes, numEdges; /* ͼеǰĶͱ */ 
}MGraph;

/* õĶнṹ뺯********************************** */

/* ѭе˳洢ṹ */
typedef struct
{
	int data[MAXSIZE];
	int front;    	/* ͷָ */
	int rear;		/* βָ룬вգָβԪصһλ */
}Queue;

/* ʼһնQ */
Status InitQueue(Queue *Q)
{
	Q->front=0;
	Q->rear=0;
	return  OK;
}

/* QΪն,򷵻TRUE,򷵻FALSE */
Status QueueEmpty(Queue Q)
{ 
	if(Q.front==Q.rear) /* пյı־ */
		return TRUE;
	else
		return FALSE;
}

/* δԪeΪQµĶβԪ */
Status EnQueue(Queue *Q,int e)
{
	if ((Q->rear+1)%MAXSIZE == Q->front)	/* ж */
		return ERROR;
	Q->data[Q->rear]=e;			/* Ԫeֵβ */
	Q->rear=(Q->rear+1)%MAXSIZE;/* rearָһλã */
								/* תͷ */
	return  OK;
}

/* вգɾQжͷԪأeֵ */
Status DeQueue(Queue *Q,int *e)
{
	if (Q->front == Q->rear)			/* пյж */
		return ERROR;
	*e=Q->data[Q->front];				/* ͷԪظֵe */
	Q->front=(Q->front+1)%MAXSIZE;	/* frontָһλã */
									/* תͷ */
	return  OK;
}
/* ****************************************************** */


void CreateMGraph(MGraph *G)
{
	int i, j;

	G->numEdges=15;
	G->numVertexes=9;

	/* 붥Ϣ */
	G->vexs[0]='A';
	G->vexs[1]='B';
	G->vexs[2]='C';
	G->vexs[3]='D';
	G->vexs[4]='E';
	G->vexs[5]='F';
	G->vexs[6]='G';
	G->vexs[7]='H';
	G->vexs[8]='I';


	for (i = 0; i < G->numVertexes; i++)/* ʼͼ */
	{
		for ( j = 0; j < G->numVertexes; j++)
		{
			G->arc[i][j]=0;
		}
	}

	G->arc[0][1]=1;
	G->arc[0][5]=1;

	G->arc[1][2]=1; 
	G->arc[1][8]=1; 
	G->arc[1][6]=1; 
	
	G->arc[2][3]=1; 
	G->arc[2][8]=1; 
	
	G->arc[3][4]=1;
	G->arc[3][7]=1;
	G->arc[3][6]=1;
	G->arc[3][8]=1;

	G->arc[4][5]=1;
	G->arc[4][7]=1;

	G->arc[5][6]=1; 
	
	G->arc[6][7]=1; 

	
	for(i = 0; i < G->numVertexes; i++)
	{
		for(j = i; j < G->numVertexes; j++)
		{
			G->arc[j][i] =G->arc[i][j];
		}
	}

}
 
Boolean visited[MAXVEX]; /* ʱ־ */

/* ڽӾȵݹ㷨 */
void DFS(MGraph G, int i)
{
	int j;
 	visited[i] = TRUE;
 	printf("%c ", G.vexs[i]);/* ӡ㣬Ҳ */
	for(j = 0; j < G.numVertexes; j++)
		if(G.arc[i][j] == 1 && !visited[j])
 			DFS(G, j);/* ΪʵڽӶݹ */
}

/* ڽӾȱ */
void DFSTraverse(MGraph G)
{
	int i;
 	for(i = 0; i < G.numVertexes; i++)
 		visited[i] = FALSE; /* ʼж״̬δʹ״̬ */
	for(i = 0; i < G.numVertexes; i++)
 		if(!visited[i]) /* δʹĶDFSͨͼִֻһ */ 
			DFS(G, i);
}

/* ڽӾĹȱ㷨 */
void BFSTraverse(MGraph G)
{
	int i, j;
	Queue Q;
	for(i = 0; i < G.numVertexes; i++)
       	visited[i] = FALSE;
    InitQueue(&Q);		/* ʼһõĶ */
    for(i = 0; i < G.numVertexes; i++)  /* ÿһѭ */
    {
		if (!visited[i])	/* δʹʹ */
		{
			visited[i]=TRUE;		/* õǰʹ */
			printf("%c ", G.vexs[i]);/* ӡ㣬Ҳ */
			EnQueue(&Q,i);		/* ˶ */
			while(!QueueEmpty(Q))	/* ǰвΪ */
			{
				DeQueue(&Q,&i);	/* ӶԪسУֵi */
				for(j=0;j<G.numVertexes;j++) 
				{ 
					/* ж뵱ǰڱδʹ  */
					if(G.arc[i][j] == 1 && !visited[j]) 
					{ 
 						visited[j]=TRUE;			/* ҵĴ˶Ϊѷ */
						printf("%c ", G.vexs[j]);	/* ӡ */
						EnQueue(&Q,j);				/* ҵĴ˶  */
					} 
				} 
			}
		}
	}
}


int main(void)
{    
	MGraph G;
	CreateMGraph(&G);
	printf("\nȱ");
	DFSTraverse(G);
	printf("\nȱ");
	BFSTraverse(G);
	return 0;
}

