#include "stdio.h"    
#include "stdlib.h"   
#include "io.h"  
#include "math.h"  
#include "time.h"

#define OK 1
#define ERROR 0
#define TRUE 1
#define FALSE 0

#define MAXSIZE 9 /* 洢ռʼ */
#define MAXEDGE 15
#define MAXVEX 9
#define INFINITY 65535

typedef int Status;	/* StatusǺ,ֵǺ״̬,OK */
typedef int Boolean; /* Booleanǲ,ֵTRUEFALSE */

typedef char VertexType; /* Ӧû */   
typedef int EdgeType; /* ϵȨֵӦû */

/* ڽӾṹ */
typedef struct
{
	VertexType vexs[MAXVEX]; /*  */
	EdgeType arc[MAXVEX][MAXVEX];/* ڽӾ,ɿ߱ */
	int numVertexes, numEdges; /* ͼеǰĶͱ */ 
}MGraph;

/* ڽӱṹ****************** */
typedef struct EdgeNode /* ߱ */ 
{
	int adjvex;    /* ڽӵ,洢öӦ± */
	int weight;		/* ڴ洢Ȩֵ,ڷͼԲҪ */
	struct EdgeNode *next; /* ,ָһڽӵ */ 
}EdgeNode;

typedef struct VertexNode /*  */ 
{
	int in;	/*  */
	char data; /* ,洢Ϣ */
	EdgeNode *firstedge;/* ߱ͷָ */   
}VertexNode, AdjList[MAXVEX];

typedef struct
{
	AdjList adjList; 
	int numVertexes,numEdges; /* ͼеǰͱ */
}graphAdjList,*GraphAdjList;
/* **************************** */

/* õĶнṹ뺯********************************** */
/* ѭе˳洢ṹ */
typedef struct
{
	int data[MAXSIZE];
	int front;    	/* ͷָ */
	int rear;		/* βָ,в,ָβԪصһλ */
}Queue;

/* ʼһնQ */
Status InitQueue(Queue *Q)
{
	Q->front=0;
	Q->rear=0;
	return  OK;
}

/* QΪն,򷵻TRUE,򷵻FALSE */
Status QueueEmpty(Queue Q)
{ 
	if(Q.front==Q.rear) /* пյı־ */
		return TRUE;
	else
		return FALSE;
}

/* δ,ԪeΪQµĶβԪ */
Status EnQueue(Queue *Q,int e)
{
	if ((Q->rear+1)%MAXSIZE == Q->front)	/* ж */
		return ERROR;
	Q->data[Q->rear]=e;			/* Ԫeֵβ */
	Q->rear=(Q->rear+1)%MAXSIZE;/* rearָһλ, */
								/* תͷ */
	return  OK;
}

/* в,ɾQжͷԪ,eֵ */
Status DeQueue(Queue *Q,int *e)
{
	if (Q->front == Q->rear)			/* пյж */
		return ERROR;
	*e=Q->data[Q->front];				/* ͷԪظֵe */
	Q->front=(Q->front+1)%MAXSIZE;	/* frontָһλ, */
									/* תͷ */
	return  OK;
}
/* ****************************************************** */



void CreateMGraph(MGraph *G)
{
	int i, j;

	G->numEdges=15;
	G->numVertexes=9;

	/* 붥Ϣ, */ 
	G->vexs[0]='A';
	G->vexs[1]='B';
	G->vexs[2]='C';
	G->vexs[3]='D';
	G->vexs[4]='E';
	G->vexs[5]='F';
	G->vexs[6]='G';
	G->vexs[7]='H';
	G->vexs[8]='I';


	for (i = 0; i < G->numVertexes; i++)/* ʼͼ */
	{
		for ( j = 0; j < G->numVertexes; j++)
		{
			G->arc[i][j]=0;
		}
	}

	G->arc[0][1]=1;
	G->arc[0][5]=1;

	G->arc[1][2]=1; 
	G->arc[1][8]=1; 
	G->arc[1][6]=1; 
	
	G->arc[2][3]=1; 
	G->arc[2][8]=1; 
	
	G->arc[3][4]=1;
	G->arc[3][7]=1;
	G->arc[3][6]=1;
	G->arc[3][8]=1;

	G->arc[4][5]=1;
	G->arc[4][7]=1;

	G->arc[5][6]=1; 
	
	G->arc[6][7]=1; 

	
	for(i = 0; i < G->numVertexes; i++)
	{
		for(j = i; j < G->numVertexes; j++)
		{
			G->arc[j][i] =G->arc[i][j];
		}
	}

}
 
/* ڽӾ󹹽ڽӱ */
void CreateALGraph(MGraph G,GraphAdjList *GL)
{
	int i,j;
	EdgeNode *e;

	*GL = (GraphAdjList)malloc(sizeof(graphAdjList));

	(*GL)->numVertexes=G.numVertexes;
	(*GL)->numEdges=G.numEdges;
	for(i= 0;i <G.numVertexes;i++) /* 붥Ϣ, */   
	{
		(*GL)->adjList[i].in=0;
		(*GL)->adjList[i].data=G.vexs[i];
		(*GL)->adjList[i].firstedge=NULL; 	/* ߱Ϊձ */
	}
	
	for(i=0;i<G.numVertexes;i++) /* ߱ */
	{ 
		for(j=0;j<G.numVertexes;j++)
		{
			if (G.arc[i][j]==1)
			{
				e=(EdgeNode *)malloc(sizeof(EdgeNode));
				e->adjvex=j;					/* ڽΪj */                         
				e->next=(*GL)->adjList[i].firstedge;	/* ǰϵָĽָ븳ֵe */
				(*GL)->adjList[i].firstedge=e;		/* ǰָָe */   
				(*GL)->adjList[j].in++;
				
			}
		}
	}
	
}

Boolean visited[MAXSIZE]; /* ʱ־ */

/* ڽӱȵݹ㷨 */
void DFS(GraphAdjList GL, int i)
{
	EdgeNode *p;
 	visited[i] = TRUE;
 	printf("%c ",GL->adjList[i].data);/* ӡ,Ҳ */
	p = GL->adjList[i].firstedge;
	while(p)
	{
 		if(!visited[p->adjvex])
 			DFS(GL, p->adjvex);/* ΪʵڽӶݹ */
		p = p->next;
 	}
}

/* ڽӱȱ */
void DFSTraverse(GraphAdjList GL)
{
	int i;
 	for(i = 0; i < GL->numVertexes; i++)
 		visited[i] = FALSE; /* ʼж״̬δʹ״̬ */
	for(i = 0; i < GL->numVertexes; i++)
 		if(!visited[i]) /* δʹĶDFS,ͨͼ,ִֻһ */ 
			DFS(GL, i);
}

/* ڽӱĹȱ㷨 */
void BFSTraverse(GraphAdjList GL)
{
	int i;
    EdgeNode *p;
	Queue Q;
	for(i = 0; i < GL->numVertexes; i++)
       	visited[i] = FALSE;
    InitQueue(&Q);
   	for(i = 0; i < GL->numVertexes; i++)
   	{
		if (!visited[i])
		{
			visited[i]=TRUE;
			printf("%c ",GL->adjList[i].data);/* ӡ,Ҳ */
			EnQueue(&Q,i);
			while(!QueueEmpty(Q))
			{
				DeQueue(&Q,&i);
				p = GL->adjList[i].firstedge;	/* ҵǰı߱ͷָ */
				while(p)
				{
					if(!visited[p->adjvex])	/* ˶δ */
 					{
 						visited[p->adjvex]=TRUE;
						printf("%c ",GL->adjList[p->adjvex].data);
						EnQueue(&Q,p->adjvex);	/* ˶ */
					}
					p = p->next;	/* ָָһڽӵ */
				}
			}
		}
	}
}

int main(void)
{    
	MGraph G;  
	GraphAdjList GL;    
	CreateMGraph(&G);
	CreateALGraph(G,&GL);

	printf("\nȱ:");
	DFSTraverse(GL);
	printf("\nȱ:");
	BFSTraverse(GL);
	return 0;
}

