#include "stdio.h"    
#include "stdlib.h"   
#include "io.h"  
#include "math.h"  
#include "time.h"

#define OK 1
#define ERROR 0
#define TRUE 1
#define FALSE 0

#define MAXEDGE 20
#define MAXVEX 20
#define INFINITY 65535

typedef int Status;	/* StatusǺ,ֵǺ״̬룬OK */

typedef struct
{
	int arc[MAXVEX][MAXVEX];
	int numVertexes, numEdges;
}MGraph;

void CreateMGraph(MGraph *G)/* ͼ */
{
	int i, j;

	/* printf("Ͷ:"); */
	G->numEdges=15;
	G->numVertexes=9;

	for (i = 0; i < G->numVertexes; i++)/* ʼͼ */
	{
		for ( j = 0; j < G->numVertexes; j++)
		{
			if (i==j)
				G->arc[i][j]=0;
			else
				G->arc[i][j] = G->arc[j][i] = INFINITY;
		}
	}

	G->arc[0][1]=10;
	G->arc[0][5]=11; 
	G->arc[1][2]=18; 
	G->arc[1][8]=12; 
	G->arc[1][6]=16; 
	G->arc[2][8]=8; 
	G->arc[2][3]=22; 
	G->arc[3][8]=21; 
	G->arc[3][6]=24; 
	G->arc[3][7]=16;
	G->arc[3][4]=20;
	G->arc[4][7]=7; 
	G->arc[4][5]=26; 
	G->arc[5][6]=17; 
	G->arc[6][7]=19; 

	for(i = 0; i < G->numVertexes; i++)
	{
		for(j = i; j < G->numVertexes; j++)
		{
			G->arc[j][i] =G->arc[i][j];
		}
	}

}

/* Prim㷨С  */
void MiniSpanTree_Prim(MGraph G)
{
	int min, i, j, k;
	int adjvex[MAXVEX];		/* ض± */
	int lowcost[MAXVEX];	/* ضߵȨֵ */
	lowcost[0] = 0;/* ʼһȨֵΪ0v0 */
			/* lowcostֵΪ0Ǵ±ĶѾ */
	adjvex[0] = 0;			/* ʼһ±Ϊ0 */
	for(i = 1; i < G.numVertexes; i++)	/* ѭ±Ϊ0ȫ */
	{
		lowcost[i] = G.arc[0][i];	/* v0֮бߵȨֵ */
		adjvex[i] = 0;					/* ʼΪv0± */
	}
	for(i = 1; i < G.numVertexes; i++)
	{
		min = INFINITY;	/* ʼСȨֵΪޣ */
						/* ͨΪܵĴ3276765535 */
		j = 1;k = 0;
		while(j < G.numVertexes)	/* ѭȫ */
		{
			if(lowcost[j]!=0 && lowcost[j] < min)/* ȨֵΪ0ȨֵСmin */
			{	
				min = lowcost[j];	/* õǰȨֵΪСֵ */
				k = j;			/* ǰСֵ±k */
			}
			j++;
		}
		printf("(%d, %d)\n", adjvex[k], k);/* ӡǰȨֵСı */
		lowcost[k] = 0;/* ǰȨֵΪ0,ʾ˶Ѿ */
		for(j = 1; j < G.numVertexes; j++)	/* ѭж */
		{
			if(lowcost[j]!=0 && G.arc[k][j] < lowcost[j]) 
			{/* ±ΪkȨֵСڴǰЩδȨֵ */
				lowcost[j] = G.arc[k][j];/* СȨֵlowcostӦλ */
				adjvex[j] = k;				/* ±ΪkĶadjvex */
			}
		}
	}
}

int main(void)
{
	MGraph G;
	CreateMGraph(&G);
	MiniSpanTree_Prim(G);
  
	return 0;
 
}