#include "stdio.h"    
#include "stdlib.h"   
#include "io.h"  
#include "math.h"  
#include "time.h"

#define OK 1
#define ERROR 0
#define TRUE 1
#define FALSE 0

#define MAXEDGE 30
#define MAXVEX 30
#define INFINITY 65535

typedef int Status;	/* StatusǺ,ֵǺ״̬룬OK */  

int *etv,*ltv; /* ¼緢ʱٷʱ飬ȫֱ */
int *stack2;   /* ڴ洢еջ */
int top2;	   /* stack2ָ */

/* ڽӾṹ */
typedef struct
{
	int vexs[MAXVEX];
	int arc[MAXVEX][MAXVEX];
	int numVertexes, numEdges;
}MGraph;

/* ڽӱṹ****************** */
typedef struct EdgeNode /* ߱  */
{
	int adjvex;    /* ڽӵ򣬴洢öӦ± */
	int weight;		/* ڴ洢ȨֵڷͼԲҪ */
	struct EdgeNode *next; /* ָһڽӵ */
}EdgeNode;

typedef struct VertexNode /*  */
{
	int in;	/*  */
	int data; /* 򣬴洢Ϣ */
	EdgeNode *firstedge;/* ߱ͷָ */
}VertexNode, AdjList[MAXVEX];

typedef struct
{
	AdjList adjList; 
	int numVertexes,numEdges; /* ͼеǰͱ */
}graphAdjList,*GraphAdjList;
/* **************************** */


void CreateMGraph(MGraph *G)/* ͼ */
{
	int i, j;
	/* printf("Ͷ:"); */
	G->numEdges=13;
	G->numVertexes=10;

	for (i = 0; i < G->numVertexes; i++)/* ʼͼ */
	{
		G->vexs[i]=i;
	}

	for (i = 0; i < G->numVertexes; i++)/* ʼͼ */
	{
		for ( j = 0; j < G->numVertexes; j++)
		{
			if (i==j)
				G->arc[i][j]=0;
			else
				G->arc[i][j]=INFINITY;
		}
	}

	G->arc[0][1]=3;
	G->arc[0][2]=4; 
	G->arc[1][3]=5; 
	G->arc[1][4]=6; 
	G->arc[2][3]=8; 
	G->arc[2][5]=7; 
	G->arc[3][4]=3;
	G->arc[4][6]=9; 
	G->arc[4][7]=4;
	G->arc[5][7]=6; 
	G->arc[6][9]=2;
	G->arc[7][8]=5;
	G->arc[8][9]=3;

}

/* ڽӾ󹹽ڽӱ */
void CreateALGraph(MGraph G,GraphAdjList *GL)
{
	int i,j;
	EdgeNode *e;

	*GL = (GraphAdjList)malloc(sizeof(graphAdjList));

	(*GL)->numVertexes=G.numVertexes;
	(*GL)->numEdges=G.numEdges;
	for(i= 0;i <G.numVertexes;i++) /* 붥Ϣ */
	{
		(*GL)->adjList[i].in=0;
		(*GL)->adjList[i].data=G.vexs[i];
		(*GL)->adjList[i].firstedge=NULL; 	/* ߱Ϊձ */
	}
	
	for(i=0;i<G.numVertexes;i++) /* ߱ */
	{ 
		for(j=0;j<G.numVertexes;j++)
		{
			if (G.arc[i][j]!=0 && G.arc[i][j]<INFINITY)
			{
				e=(EdgeNode *)malloc(sizeof(EdgeNode));
				e->adjvex=j;					/* ڽΪj */   
				e->weight=G.arc[i][j];
				e->next=(*GL)->adjList[i].firstedge;	/* ǰϵָĽָ븳ֵe */
				(*GL)->adjList[i].firstedge=e;		/* ǰָָe  */  
				(*GL)->adjList[j].in++;
				
			}
		}
	}
	
}


/*  */
Status TopologicalSort(GraphAdjList GL)
{    /* GL޻·в1л·0 */    
	EdgeNode *e;    
	int i,k,gettop;   
	int top=0;  /* ջָ±  */
	int count=0;/* ͳĸ */   
	int *stack;	/* ջΪ0Ķջ  */   
	stack=(int *)malloc(GL->numVertexes * sizeof(int) );    
	for(i = 0; i<GL->numVertexes; i++)                
		if(0 == GL->adjList[i].in) /* Ϊ0Ķջ */           
			stack[++top]=i;    

	top2=0;    
	etv=(int *)malloc(GL->numVertexes * sizeof(int) ); /* ¼緢ʱ */    
	for(i=0; i<GL->numVertexes; i++)        
		etv[i]=0;    /* ʼ */
	stack2=(int *)malloc(GL->numVertexes * sizeof(int) );/* ʼջ */

	printf("TopologicalSort:\t");
	while(top!=0)    
	{        
		gettop=stack[top--];        
		printf("%d -> ",GL->adjList[gettop].data);        
		count++;        /* iŶ㣬 */ 

		stack2[++top2]=gettop;        /* Ķѹеջ */

		for(e = GL->adjList[gettop].firstedge; e; e = e->next)        
		{            
			k=e->adjvex;            
			if( !(--GL->adjList[k].in) )        /* iŶڽӵȼ11Ϊ0ջ */                
				stack[++top]=k; 

			if((etv[gettop] + e->weight)>etv[k])    /* ¼緢ʱetvֵ */                
				etv[k] = etv[gettop] + e->weight;
		}    
	}    
	printf("\n");   
	if(count < GL->numVertexes)        
		return ERROR;    
	else       
		return OK;
}

/* ؼ·,GLΪGĸؼ */
void CriticalPath(GraphAdjList GL) 
{    
	EdgeNode *e;    
	int i,gettop,k,j;    
	int ete,lte;  /* 緢ʱٷʱ */        
	TopologicalSort(GL);   /* Уetvstack2ֵ */ 
	ltv=(int *)malloc(GL->numVertexes*sizeof(int));/* ¼緢ʱ */   
	for(i=0; i<GL->numVertexes; i++)        
		ltv[i]=etv[GL->numVertexes-1];    /* ʼ */        
	
	printf("etv:\t");   
	for(i=0; i<GL->numVertexes; i++)        
		printf("%d -> ",etv[i]);    
	printf("\n"); 

	while(top2!=0)    /* ջltv */    
	{        
		gettop=stack2[top2--];        
		for(e = GL->adjList[gettop].firstedge; e; e = e->next)        /* ¼ٷʱltvֵ */        
		{            
			k=e->adjvex;            
			if(ltv[k] - e->weight < ltv[gettop])               
				ltv[gettop] = ltv[k] - e->weight;        
		}   
	}    
	
	printf("ltv:\t");   
	for(i=0; i<GL->numVertexes; i++)        
		printf("%d -> ",ltv[i]);    
	printf("\n"); 

	for(j=0; j<GL->numVertexes; j++)        /* ete,lte͹ؼ */        
	{            
		for(e = GL->adjList[j].firstedge; e; e = e->next)            
		{                
			k=e->adjvex;                
			ete = etv[j];        /* 緢ʱ */                
			lte = ltv[k] - e->weight; /* ٷʱ */               
			if(ete == lte)    /* ȼڹؼ· */                    
				printf("<v%d - v%d> length: %d \n",GL->adjList[j].data,GL->adjList[k].data,e->weight);
		}        
	}
}


int main(void)
{    
	MGraph G;    
	GraphAdjList GL;    
	CreateMGraph(&G);
	CreateALGraph(G,&GL);
	CriticalPath(GL);
	return 0;
}
